Index: stable/HeuristicLab.Clients.Hive.Views/3.3/Extensions/FixedNumericUpDown.cs
===================================================================
--- stable/HeuristicLab.Clients.Hive.Views/3.3/Extensions/FixedNumericUpDown.cs	(revision 17059)
+++ stable/HeuristicLab.Clients.Hive.Views/3.3/Extensions/FixedNumericUpDown.cs	(revision 17059)
@@ -0,0 +1,40 @@
+﻿#region License Information
+/* HeuristicLab
+ * Copyright (C) 2002-2018 Heuristic and Evolutionary Algorithms Laboratory (HEAL)
+ *
+ * This file is part of HeuristicLab.
+ *
+ * HeuristicLab is free software: you can redistribute it and/or modify
+ * it under the terms of the GNU General Public License as published by
+ * the Free Software Foundation, either version 3 of the License, or
+ * (at your option) any later version.
+ *
+ * HeuristicLab is distributed in the hope that it will be useful,
+ * but WITHOUT ANY WARRANTY; without even the implied warranty of
+ * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
+ * GNU General Public License for more details.
+ *
+ * You should have received a copy of the GNU General Public License
+ * along with HeuristicLab. If not, see <http://www.gnu.org/licenses/>.
+ */
+#endregion
+
+using System.Windows.Forms;
+
+namespace HeuristicLab.Clients.Hive.Views.Extensions {
+  // Bugfix for NumericUpDown to disable arrow controls correctly
+  // cf. https://www.codeproject.com/Articles/16321/NumericUpDown-with-correct-read-only-behavior
+  public class FixedNumericUpDown : NumericUpDown {
+    public override void DownButton() {
+      if (ReadOnly)
+        return;
+      base.DownButton();
+    }
+
+    public override void UpButton() {
+      if (ReadOnly)
+        return;
+      base.UpButton();
+    }
+  }
+}
Index: stable/HeuristicLab.Clients.Hive.Views/3.3/HeuristicLab.Clients.Hive.Views-3.3.csproj
===================================================================
--- stable/HeuristicLab.Clients.Hive.Views/3.3/HeuristicLab.Clients.Hive.Views-3.3.csproj	(revision 15587)
+++ stable/HeuristicLab.Clients.Hive.Views/3.3/HeuristicLab.Clients.Hive.Views-3.3.csproj	(revision 17059)
@@ -101,4 +101,7 @@
   </ItemGroup>
   <ItemGroup>
+    <Compile Include="Extensions\FixedNumericUpDown.cs">
+      <SubType>Component</SubType>
+    </Compile>
     <Compile Include="HiveInformationDialog.cs">
       <SubType>Form</SubType>
@@ -168,4 +171,7 @@
     <Compile Include="StateLog\StateLogView.designer.cs">
       <DependentUpon>StateLogView.cs</DependentUpon>
+    </Compile>
+    <Compile Include="TreeView\NoDoubleClickTreeView.cs">
+      <SubType>Component</SubType>
     </Compile>
     <None Include="Plugin.cs.frame" />
Index: stable/HeuristicLab.Clients.Hive.Views/3.3/HiveItemView.Designer.cs
===================================================================
--- stable/HeuristicLab.Clients.Hive.Views/3.3/HiveItemView.Designer.cs	(revision 15587)
+++ stable/HeuristicLab.Clients.Hive.Views/3.3/HiveItemView.Designer.cs	(revision 17059)
@@ -52,5 +52,5 @@
       // storeButton
       // 
-      this.storeButton.Image = HeuristicLab.Common.Resources.VSImageLibrary.PublishToWeb;
+      this.storeButton.Image = HeuristicLab.Common.Resources.VSImageLibrary.Save;
       this.storeButton.Location = new System.Drawing.Point(0, 0);
       this.storeButton.Name = "storeButton";
Index: stable/HeuristicLab.Clients.Hive.Views/3.3/HiveTasks/HiveTaskView.cs
===================================================================
--- stable/HeuristicLab.Clients.Hive.Views/3.3/HiveTasks/HiveTaskView.cs	(revision 15587)
+++ stable/HeuristicLab.Clients.Hive.Views/3.3/HiveTasks/HiveTaskView.cs	(revision 17059)
@@ -211,4 +211,12 @@
       }
     }
+
+    private void coresNeededComboBox_SelectedIndexChanged(object sender, EventArgs e) {
+      if (Content != null && Content.Task != null) {
+        int cores;
+        if (int.TryParse(coresNeededComboBox.SelectedItem.ToString(), out cores) && Content.Task.CoresNeeded != cores)
+          Content.Task.CoresNeeded = cores;
+      }
+    }
   }
 }
Index: stable/HeuristicLab.Clients.Hive.Views/3.3/HiveTasks/HiveTaskView.designer.cs
===================================================================
--- stable/HeuristicLab.Clients.Hive.Views/3.3/HiveTasks/HiveTaskView.designer.cs	(revision 15587)
+++ stable/HeuristicLab.Clients.Hive.Views/3.3/HiveTasks/HiveTaskView.designer.cs	(revision 17059)
@@ -292,9 +292,14 @@
             "2",
             "3",
-            "4"});
+            "4",
+            "6",
+            "8",
+            "10",
+            "12"});
       this.coresNeededComboBox.Location = new System.Drawing.Point(134, 13);
       this.coresNeededComboBox.Name = "coresNeededComboBox";
       this.coresNeededComboBox.Size = new System.Drawing.Size(134, 21);
       this.coresNeededComboBox.TabIndex = 41;
+      this.coresNeededComboBox.SelectedIndexChanged += new System.EventHandler(this.coresNeededComboBox_SelectedIndexChanged);
       // 
       // memoryNeededLabel
Index: stable/HeuristicLab.Clients.Hive.Views/3.3/TreeView/NoDoubleClickTreeView.cs
===================================================================
--- stable/HeuristicLab.Clients.Hive.Views/3.3/TreeView/NoDoubleClickTreeView.cs	(revision 17059)
+++ stable/HeuristicLab.Clients.Hive.Views/3.3/TreeView/NoDoubleClickTreeView.cs	(revision 17059)
@@ -0,0 +1,34 @@
+﻿#region License Information
+/* HeuristicLab
+ * Copyright (C) 2002-2018 Heuristic and Evolutionary Algorithms Laboratory (HEAL)
+ *
+ * This file is part of HeuristicLab.
+ *
+ * HeuristicLab is free software: you can redistribute it and/or modify
+ * it under the terms of the GNU General Public License as published by
+ * the Free Software Foundation, either version 3 of the License, or
+ * (at your option) any later version.
+ *
+ * HeuristicLab is distributed in the hope that it will be useful,
+ * but WITHOUT ANY WARRANTY; without even the implied warranty of
+ * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
+ * GNU General Public License for more details.
+ *
+ * You should have received a copy of the GNU General Public License
+ * along with HeuristicLab. If not, see <http://www.gnu.org/licenses/>.
+ */
+#endregion
+
+using System;
+using System.Windows.Forms;
+
+namespace HeuristicLab.Clients.Hive.Views.TreeView {
+  // Workaround for a well-known bug in TreeView
+  // cf. https://stackoverflow.com/questions/6130297/c-how-to-avoid-treenode-check-from-happening-on-a-double-click-event
+  public class NoDoubleClickTreeView : System.Windows.Forms.TreeView {
+    protected override void WndProc(ref Message m) {
+      // Suppress WM_LBUTTONDBLCLK
+      if (m.Msg == 0x203) { m.Result = IntPtr.Zero; } else base.WndProc(ref m);
+    }
+  }
+}